/*
	BmGuiUtil.h
		$Id: BmGuiUtil.h,v 1.5 2003/09/08 20:54:26 zooey Exp $
*/
/*************************************************************************/
/*                                                                       */
/*  Beam - BEware Another Mailer                                         */
/*                                                                       */
/*  http://www.hirschkaefer.de/beam                                      */
/*                                                                       */
/*  Copyright (C) 2002 Oliver Tappe <beam@hirschkaefer.de>               */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License          */
/*  as published by the Free Software Foundation; either version 2       */
/*  of the License, or (at your option) any later version.               */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    */
/*  General Public License for more details.                             */
/*                                                                       */
/*  You should have received a copy of the GNU General Public            */
/*  License along with this program; if not, write to the                */
/*  Free Software Foundation, Inc., 59 Temple Place - Suite 330,         */
/*  Boston, MA  02111-1307, USA.                                         */
/*                                                                       */
/*************************************************************************/


#ifndef _BmGuiUtil_h
#define _BmGuiUtil_h

#include "BmString.h"

class BFont;
class BHandler;
class BMenu;
class BMenuItem;
class BMessage;
class BmListModel;
class BmListModelItem;
/*------------------------------------------------------------------------------*\
	utility functions that make menu-creation easier:
\*------------------------------------------------------------------------------*/
void AddItemToMenu( BMenu* menu, BMenuItem* item, BHandler* target=NULL);
BMenuItem* CreateMenuItem( const char* label, int32 msgWhat, 
									const char* idForShortcut=NULL);
BMenuItem* CreateMenuItem( const char* label, BMessage* msg, 
									const char* idForShortcut=NULL);

extern const char* const MSG_CHARSET;
void AddCharsetMenu( BMenu* menu, BHandler* target, int32 msgType);

void AddListToMenu( BmListModel* list, BMenu* menu, BMessage* msgTemplate,
						  BHandler* msgTarget, BFont* font, 
						  bool skipFirstLevel=false,
						  bool addNoneItem=false, const BmString shortcuts="");
void AddListItemToMenu( BmListModelItem* item, BMenu* menu, 
								BMessage* msgTemplate, BHandler* msgTarget, 
								BFont* font, bool skipThisButAddChildren=false, 
								char shortcut=0);

#endif
