/*
	BmFilterAddonPrefs.cpp

		$Id: BmFilterAddonPrefs.cpp,v 1.1 2003/07/13 18:43:26 zooey Exp $
*/
/*************************************************************************/
/*                                                                       */
/*  Beam - BEware Another Mailer                                         */
/*                                                                       */
/*  http://www.hirschkaefer.de/beam                                      */
/*                                                                       */
/*  Copyright (C) 2002 Oliver Tappe <beam@hirschkaefer.de>               */
/*                                                                       */
/*  This program is free software; you can redistribute it and/or        */
/*  modify it under the terms of the GNU General Public License          */
/*  as published by the Free Software Foundation; either version 2       */
/*  of the License, or (at your option) any later version.               */
/*                                                                       */
/*  This program is distributed in the hope that it will be useful,      */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    */
/*  General Public License for more details.                             */
/*                                                                       */
/*  You should have received a copy of the GNU General Public            */
/*  License along with this program; if not, write to the                */
/*  Free Software Foundation, Inc., 59 Temple Place - Suite 330,         */
/*  Boston, MA  02111-1307, USA.                                         */
/*                                                                       */
/*************************************************************************/


#ifdef __POWERPC__
#define BM_BUILDING_SANTAPARTSFORBEAM 1
#endif

#include "BmFilterAddonPrefs.h"

/********************************************************************************\
	BmFilterAddonPrefsView
\********************************************************************************/

/*------------------------------------------------------------------------------*\
	BmFilterAddonPrefsView()
		-	c'tor
\*------------------------------------------------------------------------------*/
BmFilterAddonPrefsView::BmFilterAddonPrefsView( minimax minmax)
	:	inherited( minmax, NULL)
{
}

/*------------------------------------------------------------------------------*\
	~BmFilterAddonPrefsView()
		-	standard d'tor
\*------------------------------------------------------------------------------*/
BmFilterAddonPrefsView::~BmFilterAddonPrefsView() {
}

/*------------------------------------------------------------------------------*\
	PropagateChange()
		-	informs any observers (the prefs-view) about a modification
\*------------------------------------------------------------------------------*/
void BmFilterAddonPrefsView::PropagateChange() {
	BMessage msg( BM_NTFY_FILTER_ADDON_MODIFIED);
	SendNotices( BM_NTFY_FILTER_ADDON_MODIFIED, &msg);
}

/*------------------------------------------------------------------------------*\
	Initialize()
		-	default implementation, does nothing
\*------------------------------------------------------------------------------*/
void BmFilterAddonPrefsView::Initialize() {
}

/*------------------------------------------------------------------------------*\
	Activate()
		-	default implementation, does nothing
\*------------------------------------------------------------------------------*/
void BmFilterAddonPrefsView::Activate() {
}
